DECLARE SUB AUS2 (A1 AS INTEGER, A2 AS INTEGER, A3 AS INTEGER, A4 AS INTEGER, Port AS INTEGER)
DECLARE SUB LED2 (L1 AS INTEGER, L2 AS INTEGER, L3 AS INTEGER, L4 AS INTEGER, Port AS INTEGER)
DECLARE SUB Schiebe (Bit AS INTEGER, Port AS INTEGER)
DECLARE SUB Anz7 (Ziffer AS INTEGER, Port AS INTEGER)
DECLARE SUB AnzPM (Plus AS INTEGER, Minus AS INTEGER, Eins AS INTEGER, Punkt AS INTEGER, Port AS INTEGER)
DEFINT A-Z
CLS
PRINT "                      ____________________________________"
PRINT "                    /                                      \"
PRINT "                     MODULAR SERIAL INTERFACE  -  Testing  "
PRINT "                          http://www.elektronik.de.vu      "
PRINT "                    \______________________________________/"
PRINT
PRINT
PRINT
PRINT "  ͻ"
PRINT "     module type       access keys      current settings  key to send   "
PRINT "  ͹"
PRINT "   7-Segment        =set  0=on/off            8         F1            "
PRINT "  Ķ"
PRINT "   Plus/Minus       +  -  1  .                 +1.        F2            "
PRINT "  Ķ"
PRINT "   LED/Low-Out      Q=1  W=2  E=3  R=4  [1] [2]  [3] [4]  F3            "
PRINT "  Ķ"
PRINT "   High-Out/Trans.  A=1  S=2  D=3  F=4  [1] [2]  [3] [4]  F4            "
PRINT "  ͼ"
PRINT
PRINT
PRINT
PRINT "       Ŀ      Ŀ"
PRINT "         COM port <- ->:       [1]        Close programm:        ESC ";
LOCATE 25, 1
PRINT "             ";
LOCATE 12, 52
COLOR 12
PRINT "0"
LOCATE 14, 51
COLOR 8
PRINT "1."
LOCATE 16, 44
PRINT "[1] [2]  [3] [4]"
LOCATE 18, 44
PRINT "[1] [2]  [3] [4]"
Num = 0
AltNum = 0
Plus = 0
Minus = 0
Eins = 0
Punkt = 0
LD1 = 0
LD2 = 0
LD3 = 0
LD4 = 0
A1 = 0
A2 = 0
A3 = 0
A4 = 0
COMM = &H3FC
DO
  I$ = INKEY$
  IF I$ <> "" THEN
    SELECT CASE I$
      CASE CHR$(0) + "P"
        IF Num > 0 AND Num < 10 THEN Num = Num - 1
      CASE CHR$(0) + "H"
        IF Num < 9 THEN Num = Num + 1
      CASE "0"
        IF Num < 10 THEN
          AltNum = Num
          Num = 10
        ELSE
          Num = AltNum
        END IF
      CASE "+"
        Plus = NOT Plus
        IF Plus THEN Minus = 0
      CASE "-"
        Minus = NOT Minus
        IF Minus THEN Plus = 0
      CASE "1"
        Eins = NOT Eins
      CASE "."
        Punkt = NOT Punkt
      CASE "Q", "q"
        LD1 = NOT LD1
      CASE "W", "w"
        LD2 = NOT LD2
      CASE "E", "e"
        LD3 = NOT LD3
      CASE "R", "r"
        LD4 = NOT LD4
      CASE "A", "a"
        A1 = NOT A1
      CASE "S", "s"
        A2 = NOT A2
      CASE "D", "d"
        A3 = NOT A3
      CASE "F", "f"
        A4 = NOT A4
      CASE CHR$(0) + ";"
        Anz7 Num, COMM
      CASE CHR$(0) + "<"
        AnzPM Plus, Minus, Eins, Punkt, COMM
      CASE CHR$(0) + "="
        LED2 LD1, LD2, LD3, LD4, COMM
      CASE CHR$(0) + ">"
        AUS2 A1, A2, A3, A4, COMM
      CASE CHR$(0) + "K"
        SELECT CASE COMM
          CASE &H2FC: COMM = &H3FC
          CASE &H3EC: COMM = &H2FC
          CASE &H2EC: COMM = &H3EC
        END SELECT
      CASE CHR$(0) + "M"
        SELECT CASE COMM
          CASE &H3EC: COMM = &H2EC
          CASE &H2FC: COMM = &H3EC
          CASE &H3FC: COMM = &H2FC
        END SELECT
      CASE CHR$(27)
        OUT COMM, 0
        SYSTEM
    END SELECT
    LOCATE 12, 51
    IF Num = 10 THEN
      COLOR 8
      PRINT " 8"
    ELSE
      COLOR 12
      PRINT Num
    END IF
    COLOR 12
    LOCATE 14, 51
    IF Plus <> 0 THEN PRINT "+";
    IF Minus <> 0 THEN PRINT "-";
    IF Plus = 0 AND Minus = 0 THEN
      COLOR 8
      PRINT "";
    END IF
    LOCATE 14, 52
    IF Eins = 0 THEN COLOR 8 ELSE COLOR 12
    PRINT "1";
    IF Punkt = 0 THEN COLOR 8 ELSE COLOR 12
    PRINT "."
    LOCATE 16, 44
    IF LD1 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[1] ";
    IF LD2 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[2]  ";
    IF LD3 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[3] ";
    IF LD4 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[4]"
    LOCATE 18, 44
    IF A1 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[1] ";
    IF A2 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[2]  ";
    IF A3 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[3] ";
    IF A4 = 0 THEN COLOR 8 ELSE COLOR 10
    PRINT "[4] "
    LOCATE 24, 34
    COLOR 7
    SELECT CASE COMM
      CASE &H3FC: PRINT "1";
      CASE &H2FC: PRINT "2";
      CASE &H3EC: PRINT "3";
      CASE &H2EC: PRINT "4";
    END SELECT
  END IF
LOOP

DEFSNG A-Z
SUB Anz7 (Ziffer AS INTEGER, Port AS INTEGER)
'Fr das 7-Segment-Anzeige Nibblemodul
'Akzeptiert 0...9 und 10 fr AUS (funktioniert nicht mit 6/9-Korrektur!)
IF Ziffer > 10 OR Ziffer < 0 THEN BEEP: BEEP: BEEP
IF Ziffer = 10 THEN Ziffer = 15
Schiebe Ziffer AND 1, Port
Schiebe ((Ziffer AND 2) / 2), Port
Schiebe ((Ziffer AND 4) / 4), Port
Schiebe ((Ziffer AND 8) / 8), Port
END SUB

SUB AnzPM (Plus AS INTEGER, Minus AS INTEGER, Eins AS INTEGER, Punkt AS INTEGER, Port AS INTEGER)
'Fr das Plus/Minus-Nibblemodul
'Akzeptiert Null (aus) oder eine Andere Zahl (ein)
Schiebe Plus, Port
Schiebe Minus OR Plus, Port
Schiebe Eins, Port
Schiebe Punkt, Port
END SUB

SUB AUS1 (Nibble AS INTEGER, Port AS INTEGER)
'Fr das High-Ausgnge/Transistoren Nibblemodul
'Akzeptiert ein Nibble (LSB = A1)
IF Nibble > 15 OR Nibble < 0 THEN BEEP: BEEP: BEEP
Schiebe Nibble AND 1, Port
Schiebe ((Nibble AND 2) / 2), Port
Schiebe ((Nibble AND 4) / 4), Port
Schiebe ((Nibble AND 8) / 8), Port
END SUB

SUB AUS2 (A1 AS INTEGER, A2 AS INTEGER, A3 AS INTEGER, A4 AS INTEGER, Port AS INTEGER)
'Fr das High-Ausgnge/Transistoren Nibblemodul
'Akzeptiert je LED eine eigene Variable (0 = 0, andere Zahl = 1)
Schiebe A1, Port
Schiebe A2, Port
Schiebe A3, Port
Schiebe A4, Port
END SUB

SUB LED1 (Nibble AS INTEGER, Port AS INTEGER)
'Fr das LED/Low-Ausgnge Nibblemodul
'Akzeptiert ein Nibble (LSB = LED1)
IF Nibble > 15 OR Nibble < 0 THEN BEEP: BEEP: BEEP
Schiebe NOT (Nibble AND 1), Port
Schiebe NOT ((Nibble AND 2) / 2), Port
Schiebe NOT ((Nibble AND 4) / 4), Port
Schiebe NOT ((Nibble AND 8) / 8), Port
END SUB

SUB LED2 (L1 AS INTEGER, L2 AS INTEGER, L3 AS INTEGER, L4 AS INTEGER, Port AS INTEGER)
'Fr das LED/Low-Ausgnge Nibblemodul
'Akzeptiert je LED eine eigene Variable (0 = 0, andere Zahl = 1)
Schiebe NOT L1, Port
Schiebe NOT L2, Port
Schiebe NOT L3, Port
Schiebe NOT L4, Port
END SUB

SUB Schiebe (Bit AS INTEGER, Port AS INTEGER)
'Gibt eine 0 oder 1 aus. Wird von den anderen SUBs benutzt.
'Akzeptiert eine 0 (0) oder eine andere Zahl (1)
IF Bit = 0 THEN
  OUT Port, 3
  OUT Port, 2
ELSE
  OUT Port, 1
  OUT Port, 0
END IF
END SUB

